
#ifndef SWARMTAXISFSM_H_
#define SWARMTAXISFSM_H_

#include "SwarmTaxisIface.h"
#include "Timer.h"

class SwarmTaxisFSM : public SwarmTaxisIface {

public: 
	SwarmTaxisFSM();
	virtual ~SwarmTaxisFSM() {}
	typedef enum {
		Forward, Coherence, Avoidance
	}State;

	void RunSwarmTaxisFSM();
	virtual void CheckInEvents() {}

	void SetTimerA(Timer* timer) {this->TimerA = timer;}
	Timer* GetTimerA() {return TimerA;}

private:
	State currentState;
	Timer* TimerA;

	void MakeTransition();
	void ExecuteEntryAction();
	void ClearEvents();
	
	void Entry_Action_Forward();
	void Entry_Action_Coherence();
	void Entry_Action_Avoidance();
};

#endif 


